aboutsummaryrefslogtreecommitdiff
path: root/pbuilder-satisfydepends-aptitude
diff options
context:
space:
mode:
Diffstat (limited to 'pbuilder-satisfydepends-aptitude')
-rwxr-xr-xpbuilder-satisfydepends-aptitude113
1 files changed, 113 insertions, 0 deletions
diff --git a/pbuilder-satisfydepends-aptitude b/pbuilder-satisfydepends-aptitude
new file mode 100755
index 0000000..6f94d74
--- /dev/null
+++ b/pbuilder-satisfydepends-aptitude
@@ -0,0 +1,113 @@
+#!/bin/bash
+# pbuilder -- personal Debian package builder
+# Copyright (C) 2001,2002,2003,2005-2007 Junichi Uekawa
+# Copyright (C) 2007 Loïc Minier
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#
+# module to satisfy build dependencies; aptitude flavor
+
+set -e
+
+. /usr/lib/pbuilder/pbuilder-satisfydepends-funcs
+
+# filter out dependencies sent on input not for this arch; deps can have
+# multiple lines; output is on a single line or "" if empty
+function filter_arch_deps() {
+ local arch="$1"
+ local INSTALLPKGMULTI
+ local INSTALLPKG
+
+ # split on ","
+ sed 's/[[:space:]]*,[[:space:]]*/\n/g' |
+ while read INSTALLPKGMULTI; do
+ echo "$INSTALLPKGMULTI" |
+ # split on "|"
+ sed 's/[[:space:]]*|[[:space:]]*/\n/g' |
+ while read INSTALLPKG; do
+ if echo "$INSTALLPKG" | grep -q '\['; then
+ if checkbuilddep_archdeps "$INSTALLPKG" "$ARCH"; then
+ continue
+ fi
+ fi
+ # output the selected package
+ echo "$INSTALLPKG"
+ done |
+ # remove the arch list and add " | " between entries
+ sed 's/\[.*\]//; $,$! s/$/ |/' |
+ xargs --no-run-if-empty
+ done |
+ # add ", " between entries
+ sed '$,$! s/$/,/' |
+ xargs --no-run-if-empty
+}
+
+function checkbuilddep_internal () {
+# Use this function to fulfill the dependency (almost)
+ local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH)
+ local BUILD_DEP_DEB_DIR
+ local BUILD_DEP_DEB_CONTROL
+ local DEPENDS
+ local CONFLICTS
+ echo " -> Attempting to satisfy build-dependencies $Id$"
+ DEPENDS="$(get_control_re "$DEBIAN_CONTROL" "$BD_REGEXP" | filter_arch_deps "$ARCH")"
+ CONFLICTS="$(get_control_re "$DEBIAN_CONTROL" "$BC_REGEXP" | filter_arch_deps "$ARCH")"
+ echo " -> Creating pbuilder-satisfydepends-dummy package"
+ BUILD_DEP_DEB_DIR="/tmp/satisfydepends-aptitude"
+ BUILD_DEP_DEB_CONTROL="$BUILD_DEP_DEB_DIR/pbuilder-satisfydepends-dummy/DEBIAN/control"
+ $CHROOTEXEC mkdir -p "$BUILD_DEP_DEB_DIR/pbuilder-satisfydepends-dummy/DEBIAN/"
+ $CHROOTEXEC sh -c "cat >\"$BUILD_DEP_DEB_CONTROL\"" <<EOF
+Package: pbuilder-satisfydepends-dummy
+Version: 0.invalid.0
+Architecture: $ARCH
+Maintainer: Debian Pbuilder Team <pbuilder-maint@lists.alioth.debian.org>
+Description: Dummy package to satisfy dependencies with aptitude - created by pbuilder
+ This package was created automatically by pbuilder and should
+EOF
+ if [ -n "$DEPENDS" ]; then
+ $CHROOTEXEC sh -c "echo \"Depends: $DEPENDS\" >>\"$BUILD_DEP_DEB_CONTROL\""
+ fi
+ if [ -n "$CONFLICTS" ]; then
+ $CHROOTEXEC sh -c "echo \"Conflicts: $CONFLICTS\" >>\"$BUILD_DEP_DEB_CONTROL\""
+ fi
+ $CHROOTEXEC sh -c "cat \"$BUILD_DEP_DEB_CONTROL\""
+ $CHROOTEXEC sh -c "dpkg-deb -b \"$BUILD_DEP_DEB_DIR/pbuilder-satisfydepends-dummy\""
+ $CHROOTEXEC apt-get -y --force-yes install aptitude
+ $CHROOTEXEC dpkg -i "$BUILD_DEP_DEB_DIR/pbuilder-satisfydepends-dummy.deb" || true
+ $CHROOTEXEC aptitude -y install pbuilder-satisfydepends-dummy
+ echo " -> Finished parsing the build-deps"
+}
+
+
+function print_help () {
+ # print out help message
+ cat <<EOF
+pbuilder-satisfydepends -- satisfy dependencies
+Copyright 2002-2007 Junichi Uekawa <dancer@debian.org>
+
+--help: give help
+--control: specify control file (debian/control, *.dsc)
+--chroot: operate inside chroot
+--binary-all: include binary-all
+--binary-arch: include binary-arch only
+--echo: echo mode, do nothing. (--force-version required for most operation)
+--force-version: skip version check.
+--continue-fail: continue even when failed.
+
+EOF
+}
+
+. /usr/lib/pbuilder/pbuilder-satisfydepends-checkparams
+